<?php


class pageapi_CallbackRegistry {

  protected static $_callbacks = array();
  protected static $_weights = array();

  static function registerCallback($callback, $args, $weight) {
    self::$_callbacks[$weight][] = array($callback, $args);
  }

  static function executeCallbacks($api) {
    ksort(self::$_callbacks, SORT_NUMERIC);
    foreach (self::$_callbacks as $weight => $callbacks) {
      foreach ($callbacks as $callback_info) {
        list($callback, $args) = $callback_info;
        $args = array_merge(array($api), $args);
        call_user_func_array($callback, $args);
      }
    }
  }
}
